## genomicsdb 1.5.4

=== CMakeLists.txt ===
#
# CMakeLists.txt
#
#
# The MIT License
#
# Copyright (c) 2016 MIT and Intel Corporation
# Copyright (c) 2018-2022 Omics Data Automation, Inc.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#

cmake_minimum_required(VERSION 3.6)

project(TileDB)
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake/Modules")

# Update git submodules
execute_process(COMMAND git submodule update --recursive --init
		WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
		RESULT_VARIABLE submodule_update_exit_code)
if(NOT(submodule_update_exit_code EQUAL 0))
  message(FATAL_ERROR "Failure to recursively update git submodules")
endif()

set(ENABLE_BLOSC False CACHE BOOL "Enable blosc compression")
set(ENABLE_ZSTD False CACHE BOOL "Enable zstd compression")
set(LIBUUID_DIR "" CACHE PATH "Path to libuuid install directory")
set(HDFS_SOURCE_DIR "deps/HDFSWrapper/hadoop-hdfs-native" CACHE PATH "Path to modified libhdfs source dir")
set(AZURE_FSCLIENT_SOURCE_DIR "deps/azure-storage-cpplite" CACHE PATH "Path to modified azure cpp client")
set(MUPARSERX_SOURCE_DIR "deps/muparserx" CACHE PATH "Path to muparserx source")

set(AWSSDK_VERSION "1.8.x" CACHE STRING "Version to aws sdk")
set(AWSSDK_ROOT_DIR "$ENV{HOME}/awssdk-install/${AWSSDK_VERSION}" CACHE PATH "Path to aws sdk")
set(AWSSDK_URL "https://github.com/aws/aws-sdk-cpp/archive/${AWSSDK_VERSION}.zip" CACHE STRING "URL to aws-sdk-cpp github release")

set(GCSSDK_VERSION "v1.24.0" CACHE STRING "Version to gcs sdk")
set(GCSSDK_ROOT_DIR "$ENV{HOME}/gcssdk-install/${GCSSDK_VERSION}" CACHE PATH "Path to gcs sdk")
set(GCSSDK_URL "https://github.com/googleapis/google-cloud-cpp/archive/${GCSSDK_VERSION}.zip" CACHE STRING "URL to google-cloud-cpp github release")

# Set the following to true downstream when TileDB is added as a subdirectory 
set(TILEDB_DISABLE_TESTS False CACHE BOOL "Disable TileDB Testing")
set(TILEDB_DISABLE_UNINSTALL False CACHE BOOL "Disable TileDB Uninstall")

# Only for Mac OS X
if(APPLE)
  set(CMAKE_MACOSX_RPATH True CACHE BOOL "Set rpath on OSX")
  set(CMAKE_FIND_FRAMEWORK LAST CACHE STRING "Find frameworks on Mac OS X last")
endif()

# Default user definitions
set(USE_MPI False CACHE BOOL "Enables MPI")
if(APPLE)
  set(USE_OPENMP False CACHE BOOL "Enables OpenMP")
else()
  set(USE_OPENMP True CACHE BOOL "Enables OpenMP")
endif()

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
  set(TILEDB_VERBOSE False CACHE BOOL "Prints TileDB errors with verbosity")
else()
  set(TILEDB_VERBOSE True CACHE BOOL "Prints TileDB errors with verbosity")
endif()

set(TILEDB_TRACE False CACHE BOOL "Trace TileDB C API")
set(USE_PARALLEL_SORT False CACHE BOOL "Enables parallel sorting.")
set(USE_HDFS True CACHE BOOL "Enables HDFS support")
set(COMPRESSION_LEVEL_GZIP "" CACHE STRING "Compression level for GZIP.")
set(COMPRESSION_LEVEL_ZSTD "" CACHE STRING "Compression level for Zstandard.")
set(COMPRESSION_LEVEL_BLOSC "" CACHE STRING "Compression level for Blosc.")

set(DO_MEMORY_PROFILING False CACHE BOOL "Collect memory consumption in parts of TileDB - high overhead")

# The DOWNLOAD_EXTRACT_TIMESTAMP option to the ExternalProject_Add() command is used to explicitly specify
# how timestamps should be handled. The default behavior is to set the timestamps of extracted contents to
# the time of extraction.
# https://cmake.org/cmake/help/latest/policy/CMP0135.html#policy:CMP0135
if(POLICY CMP0135)
  cmake_policy(SET CMP0135 NEW)
endif()

# Find required library dependencies
find_package(ZLIB REQUIRED)
include_directories(${ZLIB_INCLUDE_DIR})
set(TILEDB_LIB_DEPENDENCIES ${TILEDB_LIB_DEPENDENCIES} ${ZLIB_LIBRARIES})

find_package(libuuid REQUIRED)
include_directories(${LIBUUID_INCLUDE_DIR})
set(TILEDB_LIB_DEPENDENCIES ${TILEDB_LIB_DEPENDENCIES} ${LIBUUID_LIBRARY})

# LZ4 source is directly included in source see <TileDB>/codec/external
# find_package(LZ4)
# include_directories(${LZ4_INCLUDE_DIR})
# set(TILEDB_LIB_DEPENDENCIES ${TILEDB_LIB_DEPENDENCIES} ${LZ4_LIBRARIES})

# Blosc and ZStd are dynamically loaded, so no need to perform find_package
if(ENABLE_BLOSC)
    # find_package(BLOSC REQUIRED)
    # include_directories(${BLOSC_INCLUDE_DIR})
    # set(TILEDB_LIB_DEPENDENCIES ${TILEDB_LIB_DEPENDENCIES} ${BLOSC_LIBRARIES})
    add_definitions(-DENABLE_BLOSC)
endif()
if(ENABLE_ZSTD)
    # find_package(ZSTD REQUIRED)
    # include_directories(${ZSTD_INCLUDE_DIR})
    # set(TILEDB_LIB_DEPENDENCIES ${TILEDB_LIB_DEPENDENCIES} ${ZSTD_LIBRARIES})
    add_definitions(-DENABLE_ZSTD)
endif()

find_package(OpenSSL REQUIRED)
include_directories(${OPENSSL_INCLUDE_DIR})
set(TILEDB_LIB_DEPENDENCIES ${TILEDB_LIB_DEPENDENCIES} ${OPENSSL_LIBRARIES})

find_package(CURL REQUIRED)
include_directories(${CURL_INCLUDE_DIR})
set(TILEDB_LIB_DEPENDENCIES ${TILEDB_LIB_DEPENDENCIES} ${CURL_LIBRARIES})

# Build Azure cpp lite client added as a dependency
include_directories(${AZURE_FSCLIENT_SOURCE_DIR}/include ${AZURE_FSCLIENT_SOURCE_DIR}/adls/include)
add_subdirectory(${AZURE_FSCLIENT_SOURCE_DIR})
set(TILEDB_LIB_DEPENDENCIES ${TILEDB_LIB_DEPENDENCIES} azure-storage-adls)

# Build AWS S3 client static libraries
find_package(S3Client REQUIRED)
include_directories(${AWSSDK_INCLUDE_DIR})
set(TILEDB_LIB_DEPENDENCIES ${TILEDB_LIB_DEPENDENCIES} ${AWSSDK_LINK_LIBRARIES})

# Build GCS Storage client static libraries
find_package(GCSClient REQUIRED)
include_directories(${GCSSDK_INCLUDE_DIR})
set(TILEDB_LIB_DEPENDENCIES ${TILEDB_LIB_DEPENDENCIES} ${GCSSDK_LINK_LIBRARIES})

# libaws-c-common.a needs dl libs
set(TILEDB_LIB_DEPENDENCIES ${TILEDB_LIB_DEPENDENCIES} ${CMAKE_DL_LIBS})

# Build MuParserX source code added as a dependency
include_directories(${MUPARSERX_SOURCE_DIR}/parser)
add_subdirectory(${MUPARSERX_SOURCE_DIR})
set(TILEDB_LIB_DEPENDENCIES ${TILEDB_LIB_DEPENDENCIES} muparserx)

# Find optional library dependencies
find_package(Doxygen)

if(USE_MPI)
  find_package(MPI REQUIRED)
  include_directories(${MPI_CXX_INCLUDE_PATH})
  set(TILEDB_LIB_DEPENDENCIES ${TILEDB_LIB_DEPENDENCIES} ${MPI_CXX_LIBRARIES})
endif()
if(USE_OPENMP AND NOT APPLE)
  find_package(OpenMP REQUIRED)
endif()

# Add HDFS support
if(USE_HDFS)
  find_package(HDFS REQUIRED)
  set(TILEDB_LIB_DEPENDENCIES ${TILEDB_LIB_DEPENDENCIES} ${JAVA_JVM_LIBRARY})
endif()

# Add pthreads as a dependency
set(CMAKE_THREAD_PREFER_PTHREAD True)
find_package(Threads REQUIRED)
if(DEFINED CMAKE_THREAD_LIBS_INIT AND (CMAKE_USE_PTHREADS_INIT OR CMAKE_HP_PTHREADS_INIT))
  set(TILEDB_LIB_DEPENDENCIES ${TILEDB_LIB_DEPENDENCIES} ${CMAKE_THREAD_LIBS_INIT})
endif()

# TODO: Fix this - AWSSDK has some sort of transitive dependency on CoreFoundation,
# add this explicitly for now even though CMAKE_FIND_FRAMEWORK is set to LAST
if(APPLE)
  set(TILEDB_LIB_DEPENDENCIES ${TILEDB_LIB_DEPENDENCIES} "-framework CoreFoundation")
endif()

# Set C++17 as required standard for all C++ targets.
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

get_property(dirs DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY INCLUDE_DIRECTORIES)

# Set compiler flags
set(CMAKE_CXX_FLAGS_DEBUG "-DDEBUG -g3 -gdwarf-3 -Wall")
set(CMAKE_CXX_FLAGS_RELEASE "-DNDEBUG -O3 -fvisibility=hidden")
set(CMAKE_CXX_FLAGS_COVERAGE "-DDEBUG -g3 -gdwarf-3 --coverage")
if(APPLE)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-inconsistent-missing-override")
else()
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-literal-suffix")
endif()

if(USE_OPENMP AND NOT APPLE)
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
endif()

if (NOT APPLE)
  set(CMAKE_C_FLAGS "-std=gnu11")
endif()

# Add definitions
add_definitions(-D_FILE_OFFSET_BITS=64)
if(USE_MPI)
  add_definitions(-DHAVE_MPI)
endif()
if(USE_OPENMP AND NOT APPLE)
  add_definitions(-DHAVE_OPENMP)
endif()
if(TILEDB_VERBOSE)
  add_definitions(-DTILEDB_VERBOSE)
  message(STATUS "The TileDB library is compiled with verbosity.")
endif()
if(TILEDB_TRACE)
  if(CMAKE_BUILD_TYPE STREQUAL "Debug")
     add_definitions(-DTILEDB_TRACE)
     message(STATUS "The TileDB library is compiled with trace.")
  else()
     message(STATUS "TileDB in release mode cannot have trace. CMAKE_BUILD_TYPE=" ${CMAKE_BUILD_TYPE})
  endif()
endif()
if(USE_PARALLEL_SORT)
  add_definitions(-DUSE_PARALLEL_SORT)
  message(STATUS "Will use parallel sort.")
endif()
if(COMPRESSION_LEVEL_GZIP)
  add_definitions(-DTILEDB_COMPRESSION_LEVEL_GZIP=${COMPRESSION_LEVEL_GZIP})
  message(STATUS "Set GZIP compression level to ${COMPRESSION_LEVEL_GZIP}.")
endif()
if(COMPRESSION_LEVEL_ZSTD)
  add_definitions(-DTILEDB_COMPRESSION_LEVEL_ZSTD=${COMPRESSION_LEVEL_ZSTD})
  message(STATUS 
          "Set Zstandard compression level to ${COMPRESSION_LEVEL_ZSTD}."
)
endif()
if(COMPRESSION_LEVEL_BLOSC)
  add_definitions(-DTILEDB_COMPRESSION_LEVEL_BLOSC=${COMPRESSION_LEVEL_BLOSC})
  message(STATUS "Set Blosc compression level to ${COMPRESSION_LEVEL_BLOSC}.")
endif()
if(DO_MEMORY_PROFILING)
    message(STATUS "Enabling memory consumption profiling during consolidation")
    add_definitions(-DDO_MEMORY_PROFILING=1)
endif()

# Build TileDB library
add_subdirectory(core)

# Enable testing
if(NOT TILEDB_DISABLE_TESTING)
  enable_testing()
  add_custom_target(tests COMMAND ${CMAKE_CTEST_COMMAND} -V)

  # Build unit tests
  add_subdirectory(test)
endif()

# Build examples
add_subdirectory(examples)

# Doxygen documentation
if(DOXYGEN_FOUND)
  file(GLOB_RECURSE TILEDB_CORE_HEADERS "core/include/*.h")
  add_custom_command(
     OUTPUT ${CMAKE_BINARY_DIR}/doxyfile.in
      COMMAND mkdir -p doxygen
      COMMAND echo INPUT = ${CMAKE_SOURCE_DIR}/doc/mainpage.dox 
              ${TILEDB_CORE_HEADERS} > ${CMAKE_BINARY_DIR}/doxyfile.in
      COMMAND echo FILE_PATTERNS = *.h >> ${CMAKE_BINARY_DIR}/doxyfile.in
      COMMENT "Preparing for Doxygen documentation" VERBATIM
  )
  add_custom_target(
      doc ${DOXYGEN_EXECUTABLE} ${CMAKE_SOURCE_DIR}/doc/Doxyfile.mk > 
          ${CMAKE_BINARY_DIR}/Doxyfile.log 2>&1
      COMMENT "Generating API documentation with Doxygen" VERBATIM
      DEPENDS ${CMAKE_BINARY_DIR}/doxyfile.in
  )
endif(DOXYGEN_FOUND)

# Uninstall
if(NOT TILEDB_DISABLE_UNINSTALL)
  set(CMD "xargs printf '-- Uninstalling: %s\\\\n' <install_manifest.txt")
  add_custom_target(
    uninstall
    COMMAND echo "Uninstalling TileDB..."
    COMMAND eval "${CMD}"
    COMMAND xargs rm -f < install_manifest.txt
    COMMAND echo "TileDB uninstalled"
    )
endif()

=== Makefile ===
# Makefile for htslib, a C library for high-throughput sequencing data formats.
#
#    Copyright (C) 2013-2020 Genome Research Ltd.
#
#    Author: John Marshall <jm18@sanger.ac.uk>
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
# DEALINGS IN THE SOFTWARE.

CC     = gcc
AR     = ar
RANLIB = ranlib
SOURCE_DIR = .

# Default libraries to link if configure is not used
htslib_default_libs = -lz -lm -lbz2 -llzma -lcurl

CPPFLAGS =
# TODO: make the 64-bit support for VCF optional via configure, for now add -DVCF_ALLOW_INT64
#       to CFLAGS manually, here or in config.mk if the latter exists.
# TODO: probably update cram code to make it compile cleanly with -Wc++-compat
# For testing strict C99 support add -std=c99 -D_XOPEN_SOURCE=600
#CFLAGS   = -g -Wall -O2 -pedantic -std=c99 -D_XOPEN_SOURCE=600 -D__FUNCTION__=__func__
ifdef DEBUG
  CFLAGS = -DDEBUG -g3 -gdwarf-3
  LDFLAGS  = -g3 -gdwarf-3
else
  CFLAGS = -O3
  LDFLAGS  =
endif
ifdef PROFILE
  CFLAGS += -pg
endif
CFLAGS += -Wall -fPIC
EXTRA_CFLAGS_PIC = 
LDFLAGS  =
LIBS     = $(htslib_default_libs)

prefix      = /usr/local
exec_prefix = $(prefix)
bindir      = $(exec_prefix)/bin
includedir  = $(prefix)/include
libdir      = $(exec_prefix)/lib
libexecdir  = $(exec_prefix)/libexec
datarootdir = $(prefix)/share
mandir      = $(datarootdir)/man
man1dir     = $(mandir)/man1
man5dir     = $(mandir)/man5
man7dir     = $(mandir)/man7
pkgconfigdir= $(libdir)/pkgconfig

MKDIR_P = mkdir -p
INSTALL = install -p
INSTALL_DATA    = $(INSTALL) -m 644
INSTALL_DIR     = $(MKDIR_P) -m 755
INSTALL_LIB     = $(INSTALL_DATA)
INSTALL_MAN     = $(INSTALL_DATA)
INSTALL_PROGRAM = $(INSTALL)

# Set by config.mk if plugins are enabled
plugindir =

BUILT_PROGRAMS = \
	bgzip \
	htsfile \
	tabix

BUILT_TEST_PROGRAMS = \
	test/hts_endian \
	test/fieldarith \
	test/hfile \
	test/pileup \
	test/plugins-dlhts \
	test/sam \
	test/test_bgzf \
	test/test_kfunc \
	test/test_kstring \
	test/test_realn \
	test/test-regidx \
	test/test_str2int \
	test/test_view \
	test/test_index \
	test/test-vcf-api \
	test/test-vcf-sweep \
	test/test-bcf-sr \
	test/fuzz/hts_open_fuzzer.o \
	test/test-bcf-translate \
	test/test-parse-reg

BUILT_THRASH_PROGRAMS = \
	test/thrash_threads1 \
	test/thrash_threads2 \
	test/thrash_threads3 \
	test/thrash_threads4 \
	test/thrash_threads5 \
	test/thrash_threads6 \
	test/thrash_threads7

all: lib-static lib-shared $(BUILT_PROGRAMS) plugins $(BUILT_TEST_PROGRAMS) \
     htslib_static.mk htslib-uninstalled.pc

HTSPREFIX =
include $(SOURCE_DIR)/htslib_vars.mk

# If not using GNU make, you need to copy the version number from version.sh
# into here.
PACKAGE_VERSION := $(shell ./version.sh)

LIBHTS_SOVERSION = 3
MACH_O_COMPATIBILITY_VERSION = $(LIBHTS_SOVERSION)

# $(NUMERIC_VERSION) is for items that must have a numeric X.Y.Z string
# even if this is a dirty or untagged Git working tree.
NUMERIC_VERSION := $(shell ./version.sh numeric)

# Force version.h to be remade if $(PACKAGE_VERSION) has changed.
version.h: $(if $(wildcard version.h),$(if $(findstring "$(PACKAGE_VERSION)",$(shell cat version.h)),,force))

version.h:
	echo '#define HTS_VERSION_TEXT "$(PACKAGE_VERSION)"' > $@

print-version:
	@echo $(PACKAGE_VERSION)

show-version:
	@echo PACKAGE_VERSION = $(PACKAGE_VERSION)
	@echo NUMERIC_VERSION = $(NUMERIC_VERSION)

.SUFFIXES: .bundle .c .cygdll .dll .o .pico .so

.c.o:
	$(CC) $(CFLAGS) -I$(SOURCE_DIR) -I. $(CPPFLAGS) -c -o $@ $<

.c.pico:
	$(CC) $(CFLAGS) -I$(SOURCE_DIR) -I. $(CPPFLAGS) $(EXTRA_CFLAGS_PIC) -c -o $@ $<


LIBHTS_OBJS = \
	kfunc.o \
	knetfile.o \
	kstring.o \
	bcf_sr_sort.o \
	bgzf.o \
	errmod.o \
	faidx.o \
	header.o \
	hfile.o \
	hfile_net.o \
	hts.o \
	hts_os.o\
	md5.o \
	multipart.o \
	probaln.o \
	realn.o \
	regidx.o \
	region.o \
	sam.o \
	synced_bcf_reader.o \
	vcf_sweep.o \
	tbx.o \
	textutils.o \
	thread_pool.o \
	vcf.o \
	vcfutils.o \
	cram/cram_codecs.o \
	cram/cram_decode.o \
	cram/cram_encode.o \
	cram/cram_external.o \
	cram/cram_index.o \
	cram/cram_io.o \
	cram/cram_samtools.o \
	cram/cram_stats.o \
	cram/mFILE.o \
	cram/open_trace_file.o \
	cram/pooled_alloc.o \
	cram/rANS_static.o \
	cram/string_alloc.o \
	$(NONCONFIGURE_OBJS)

# Without configure we wish to have a rich set of default figures,
# but we still need conditional inclusion as we wish to still
# support ./configure --disable-blah.
NONCONFIGURE_OBJS = hfile_libcurl.o

PLUGIN_EXT  =
PLUGIN_OBJS =

cram_h = cram/cram.h $(cram_samtools_h) $(header_h) $(cram_structs_h) $(cram_io_h) cram/cram_encode.h cram/cram_decode.h cram/cram_stats.h cram/cram_codecs.h cram/cram_index.h $(htslib_cram_h)
cram_io_h = cram/cram_io.h $(cram_misc_h)
cram_misc_h = cram/misc.h
cram_os_h = cram/os.h $(htslib_hts_endian_h)
cram_samtools_h = cram/cram_samtools.h $(htslib_sam_h)
cram_structs_h = cram/cram_structs.h $(htslib_thread_pool_h) $(htslib_cram_h) cram/string_alloc.h cram/mFILE.h $(htslib_khash_h)
cram_open_trace_file_h = cram/open_trace_file.h cram/mFILE.h
bcf_sr_sort_h = bcf_sr_sort.h $(htslib_synced_bcf_reader_h) $(htslib_kbitset_h)
header_h = header.h cram/string_alloc.h cram/pooled_alloc.h $(htslib_khash_h) $(htslib_kstring_h) $(htslib_sam_h)
hfile_internal_h = hfile_internal.h $(htslib_hts_defs_h) $(htslib_hfile_h) $(textutils_internal_h)
hts_internal_h = hts_internal.h $(htslib_hts_h) $(textutils_internal_h)
sam_internal_h = sam_internal.h $(htslib_sam_h)
textutils_internal_h = textutils_internal.h $(htslib_kstring_h)
thread_pool_internal_h = thread_pool_internal.h $(htslib_thread_pool_h)


# To be effective, config.mk needs to appear after most Makefile variables are
# set but before most rules appear, so that it can both use previously-set
# variables in its own rules' prerequisites and also update variables for use
# in later rules' prerequisites.

# If your make doesn't accept -include, change this to 'include' if you are
# using the configure script or just comment the line out if you are not.
-include config.mk

# Usually config.h is generated by running configure or config.status,
# but if those aren't used create a default config.h here.
config.h:
	echo '/* Default config.h generated by Makefile */' > $@
	echo '#define HAVE_LIBBZ2 1' >> $@
	echo '#define HAVE_LIBLZMA 1' >> $@
	echo '#ifndef __APPLE__' >> $@
	echo '#define HAVE_LZMA_H 1' >> $@
	echo '#endif' >> $@
	echo '#define HAVE_DRAND48 1' >> $@
	echo '#define HAVE_LIBCURL 1' >> $@

# And similarly for htslib.pc.tmp ("pkg-config template").  No dependency
# on htslib.pc.in listed, as if that file is newer the usual way to regenerate
# this target is via configure or config.status rather than this rule.
htslib.pc.tmp:
	sed -e '/^static_libs=/s/@static_LIBS@/$(htslib_default_libs)/;s#@[^-][^@]*@##g' htslib.pc.in > $@

# Create a makefile fragment listing the libraries and LDFLAGS needed for
# static linking.  This can be included by projects that want to build
# and link against the htslib source tree instead of an installed library.
htslib_static.mk: htslib.pc.tmp
	sed -n '/^static_libs=/s/[^=]*=/HTSLIB_static_LIBS = /p;/^static_ldflags=/s/[^=]*=/HTSLIB_static_LDFLAGS = /p' $< > $@


lib-static: libhts.a

# $(shell), :=, and ifeq/.../endif are GNU Make-specific.  If you don't have
# GNU Make, comment out the parts of these conditionals that don't apply.
ifneq "$(origin PLATFORM)" "file"
PLATFORM := $(shell uname -s)
endif
ifeq "$(PLATFORM)" "Darwin"
SHLIB_FLAVOUR = dylib
lib-shared: libhts.dylib
else ifeq "$(findstring CYGWIN,$(PLATFORM))" "CYGWIN"
SHLIB_FLAVOUR = cygdll
lib-shared: cyghts-$(LIBHTS_SOVERSION).dll
else ifeq "$(findstring MSYS,$(PLATFORM))" "MSYS"
SHLIB_FLAVOUR = dll
lib-shared: hts-$(LIBHTS_SOVERSION).dll
else ifeq "$(findstring MINGW,$(PLATFORM))" "MINGW"
SHLIB_FLAVOUR = dll
lib-shared: hts-$(LIBHTS_SOVERSION).dll
else
SHLIB_FLAVOUR = so
lib-shared: libhts.so
endif

BUILT_PLUGINS = $(PLUGIN_OBJS:.o=$(PLUGIN_EXT))

plugins: $(BUILT_PLUGINS)


libhts.a: $(LIBHTS_OBJS)
	@-rm -f $@
	$(AR) -rc $@ $(LIBHTS_OBJS)
	-$(RANLIB) $@

print-config:
	@echo LDFLAGS = $(LDFLAGS)
	@echo LIBHTS_OBJS = $(LIBHTS_OBJS)
	@echo LIBS = $(LIBS)
	@echo PLATFORM = $(PLATFORM)

# The target here is libhts.so, as that is the built file that other rules
# depend upon and that is used when -lhts appears in other program's recipes.
# As a byproduct invisible to make, libhts.so.NN is also created, as it is the
# file used at runtime (when $LD_LIBRARY_PATH includes the build directory).

libhts.so: $(LIBHTS_OBJS:.o=.pico)
	$(CC) -shared -Wl,-soname,libhts.so.$(LIBHTS_SOVERSION) $(LDFLAGS) -o $@ $(LIBHTS_OBJS:.o=.pico) $(LIBS) -lpthread
	ln -sf $@ libhts.so.$(LIBHTS_SOVERSION)

# Similarly this also creates libhts.NN.dylib as a byproduct, so that programs
# when run can find this uninstalled shared library (when $DYLD_LIBRARY_PATH
# includes this project's build directory).

libhts.dylib: $(LIBHTS_OBJS)
	$(CC) -dynamiclib -install_name $(libdir)/libhts.$(LIBHTS_SOVERSION).dylib -current_version $(NUMERIC_VERSION) -compatibility_version $(MACH_O_COMPATIBILITY_VERSION) $(LDFLAGS) -o $@ $(LIBHTS_OBJS) $(LIBS)
	ln -sf $@ libhts.$(LIBHTS_SOVERSION).dylib

cyghts-$(LIBHTS_SOVERSION).dll libhts.dll.a: $(LIBHTS_OBJS)
	$(CC) -shared -Wl,--out-implib=libhts.dll.a -Wl,--enable-auto-import $(LDFLAGS) -o $@ -Wl,--whole-archive $(LIBHTS_OBJS) -Wl,--no-whole-archive $(LIBS) -lpthread

hts-$(LIBHTS_SOVERSION).dll hts.dll.a: $(LIBHTS_OBJS)
	$(CC) -shared -Wl,--out-implib=hts.dll.a -Wl,--enable-auto-import -Wl,--exclude-all-symbols $(LDFLAGS) -o $@ -Wl,--whole-archive $(LIBHTS_OBJS) -Wl,--no-whole-archive $(LIBS) -lpthread

# Target to allow htslib.mk to build all the object files before it
# links the shared and static libraries.
hts-object-files: $(LIBHTS_OBJS)
	touch $@

%.so: %.pico libhts.so
	$(CC) -shared -Wl,-E $(LDFLAGS) -o $@ $< libhts.so $(LIBS) -lpthread

%.bundle: %.o libhts.dylib
	$(CC) -bundle -Wl,-undefined,dynamic_lookup $(LDFLAGS) -o $@ $< libhts.dylib $(LIBS)

%.cygdll: %.o libhts.dll.a
	$(CC) -shared $(LDFLAGS) -o $@ $< libhts.dll.a $(LIBS)

%.dll: %.o hts.dll.a
	$(CC) -shared $(LDFLAGS) -o $@ $< hts.dll.a $(LIBS)


bgzf.o bgzf.pico: bgzf.c config.h $(htslib_hts_h) $(htslib_bgzf_h) $(htslib_hfile_h) $(htslib_thread_pool_h) $(htslib_hts_endian_h) cram/pooled_alloc.h $(hts_internal_h) $(htslib_khash_h)
errmod.o errmod.pico: errmod.c config.h $(htslib_hts_h) $(htslib_ksort_h) $(htslib_hts_os_h)
kstring.o kstring.pico: kstring.c config.h $(htslib_kstring_h)
knetfile.o knetfile.pico: knetfile.c config.h $(htslib_hts_log_h) $(htslib_knetfile_h)
header.o header.pico: header.c config.h $(textutils_internal_h) $(header_h)
hfile.o hfile.pico: hfile.c config.h $(htslib_hfile_h) $(hfile_internal_h) $(htslib_kstring_h) $(hts_internal_h) $(htslib_khash_h)
hfile_gcs.o hfile_gcs.pico: hfile_gcs.c config.h $(htslib_hts_h) $(htslib_kstring_h) $(hfile_internal_h)
hfile_libcurl.o hfile_libcurl.pico: hfile_libcurl.c config.h $(hfile_internal_h) $(htslib_hts_h) $(htslib_kstring_h) $(htslib_khash_h)

=== examples/CMakeLists.txt ===
#
# examples/CMakeLists.txt
#
#
# The MIT License
#
# Copyright (c) 2016 MIT and Intel Corporation
# Copyright (c) 2018-2019 Omics Data Automation, Inc.
# Copyright (c) 2023 dātma, inc™
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#

# Function that builds an executable per example
function(build_TileDB_example TARGET)
  add_executable(${TARGET} EXCLUDE_FROM_ALL src/${TARGET}.cc)
  target_link_libraries(${TARGET} tiledb_static ${TILEDB_LIB_DEPENDENCIES})
endfunction()

# Get the example sources
file(GLOB TILEDB_EXAMPLE_SOURCES "src/*.cc")

# Include TileDB C API headers
include_directories("${CMAKE_SOURCE_DIR}/core/include/c_api/")

# Initialize name for example binaries
set(EXAMPLE_BINS)

# Iterate over all example sources and call the build function
foreach(EXAMPLE_SOURCE ${TILEDB_EXAMPLE_SOURCES})
  # Get the binary name
  get_filename_component(EXAMPLE_STRIPPED ${EXAMPLE_SOURCE} NAME)
  STRING(REGEX REPLACE ".cc$" "" EXAMPLE_BIN ${EXAMPLE_STRIPPED})
  set(EXAMPLE_BINS ${EXAMPLE_BINS} ${EXAMPLE_BIN})

  # Build example executable
  build_TileDB_example(${EXAMPLE_BIN})
endforeach()

# Add custom target 'examples'
add_custom_target(examples DEPENDS tiledb_static)
add_dependencies(examples ${EXAMPLE_BINS})

# Run a subset of examples for Continuous Integration Testing
if(NOT TILEDB_DISABLE_TESTING)
  set(CI_TESTS ${CMAKE_SOURCE_DIR}/examples/run_examples.sh &&
    echo "Running diff with expected_results" &&
    diff log ${CMAKE_SOURCE_DIR}/examples/expected_results)
  add_test(NAME ci_tests COMMAND ${CI_TESTS})
  add_custom_target(ci_tests COMMAND ${CI_TESTS} DEPENDS examples)
  add_dependencies(tests ci_tests)
endif()

=== debian/changelog ===
genomicsdb (1.5.4-5) unstable; urgency=medium

  * Restricting architectures for autopkgtests

 -- Pierre Gruet <pgt@debian.org>  Sun, 16 Feb 2025 10:28:05 +0100

genomicsdb (1.5.4-4) unstable; urgency=medium

  * Ignoring test failures for arch-dependent packages, not arch-indep ones

 -- Pierre Gruet <pgt@debian.org>  Mon, 30 Dec 2024 11:59:45 +0100

genomicsdb (1.5.4-3) unstable; urgency=medium

  * Ignoring failures in build-time tests

 -- Pierre Gruet <pgt@debian.org>  Mon, 30 Dec 2024 11:01:09 +0100

genomicsdb (1.5.4-2) unstable; urgency=medium

  * Adding fmt formatters to build against fmtlib/10.x (Closes: #1086565)

 -- Pierre Gruet <pgt@debian.org>  Sat, 30 Nov 2024 14:32:54 +0100

genomicsdb (1.5.4-1) unstable; urgency=medium

  * New upstream version 1.5.4
  * Refreshing patches
  * Depending on mpi-default-bin instead of openmpi-bin, for installation on
    32-bit arches (Closes: #1079485)
  * Patching an additional file to account for catch2 v3
  * Build-Depending on libcatch2-dev instead of obsolete catch2

 -- Pierre Gruet <pgt@debian.org>  Thu, 31 Oct 2024 09:38:30 +0100

=== debian/control ===
Source: genomicsdb
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Pierre Gruet <pgt@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
               default-jdk,
               javahelper,
               libbz2-dev,
               libcatch2-dev,
               libcurlpp-dev,
               libfmt-dev,
               libmuparserx-dev,
               libprotobuf-dev,
               libspdlog-dev,
               libssl-dev,
               liblzma-dev,
               maven-debian-helper,
               mpi-default-dev,
               protobuf-compiler,
               rapidjson-dev,
               testng <!nocheck>,
               uuid-dev
Build-Depends-Arch: chrpath
Build-Depends-Indep: libbuild-helper-maven-plugin-java,
                     libcommons-io-java,
                     libcommons-lang3-java,
                     libgetopt-java,
                     libguava-java,
                     libhtsjdk-java,
                     libjson-simple-java,
                     liblog4j2-java,
                     libmaven-antrun-plugin-java,
                     libprotobuf-java,
                     libsurefire-java
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/med-team/genomicsdb
Vcs-Git: https://salsa.debian.org/med-team/genomicsdb.git
Homepage: https://www.genomicsdb.org/
Rules-Requires-Root: no

Package: libgenomicsdb-java
Section: java
Architecture: all
Depends: ${maven:Depends},
         ${java:Depends},
         libgenomicsdb-jni (>= ${source:Version}),
         libgenomicsdb-jni (<< ${source:Version}.1~),
         ${misc:Depends}
Description: sparse array storage library for genomics (Java library)
 GenomicsDB is built on top of a htslib fork and an internal array storage
 system for importing, querying and transforming variant data. Variant data is
 sparse by nature (sparse relative to the whole genome) and using sparse array
 data stores is a perfect fit for storing such data.
 .
 The GenomicsDB stores variant data in a 2D array where:
  - Each column corresponds to a genomic position (chromosome + position);
  - Each row corresponds to a sample in a VCF (or CallSet in the GA4GH
    terminology);
  - Each cell contains data for a given sample/CallSet at a given position;
    data is stored in the form of cell attributes;
  - Cells are stored in column major order - this makes accessing cells with
    the same column index (i.e. data for a given genomic position over all
    samples) fast.
  - Variant interval/gVCF interval data is stored in a cell at the start of the
    interval. The END is stored as a cell attribute. For variant intervals
    (such as deletions and gVCF REF blocks), an additional cell is stored at
    the END value of the variant interval. When queried for a given genomic
    position, the query library performs an efficient sweep to determine all
    intervals that intersect with the queried position.
 .
 This package contains the Java library.

Package: libgenomicsdb-jni
Section: java
Architecture: any
Depends: ${shlibs:Depends},
         libgenomicsdb1 (= ${binary:Version}),
         ${misc:Depends}
Description: sparse array storage library for genomics (Java native bindings)
 GenomicsDB is built on top of a htslib fork and an internal array storage
 system for importing, querying and transforming variant data. Variant data is
 sparse by nature (sparse relative to the whole genome) and using sparse array
 data stores is a perfect fit for storing such data.
 .
 The GenomicsDB stores variant data in a 2D array where:
  - Each column corresponds to a genomic position (chromosome + position);
  - Each row corresponds to a sample in a VCF (or CallSet in the GA4GH
    terminology);
  - Each cell contains data for a given sample/CallSet at a given position;
    data is stored in the form of cell attributes;
  - Cells are stored in column major order - this makes accessing cells with
    the same column index (i.e. data for a given genomic position over all
    samples) fast.
  - Variant interval/gVCF interval data is stored in a cell at the start of the
    interval. The END is stored as a cell attribute. For variant intervals
    (such as deletions and gVCF REF blocks), an additional cell is stored at
    the END value of the variant interval. When queried for a given genomic
    position, the query library performs an efficient sweep to determine all
    intervals that intersect with the queried position.
 .
 This package contains the Java native bindings.

Package: genomicsdb-tools
Architecture: any
Depends: ${shlibs:Depends},
         libgenomicsdb1 (= ${binary:Version}),
         ${misc:Depends}
Description: sparse array storage library for genomics (tools)
 GenomicsDB is built on top of a htslib fork and an internal array storage
 system for importing, querying and transforming variant data. Variant data is
 sparse by nature (sparse relative to the whole genome) and using sparse array
 data stores is a perfect fit for storing such data.
 .
 The GenomicsDB stores variant data in a 2D array where:
  - Each column corresponds to a genomic position (chromosome + position);
  - Each row corresponds to a sample in a VCF (or CallSet in the GA4GH
    terminology);
  - Each cell contains data for a given sample/CallSet at a given position;
    data is stored in the form of cell attributes;
  - Cells are stored in column major order - this makes accessing cells with
    the same column index (i.e. data for a given genomic position over all
    samples) fast.
  - Variant interval/gVCF interval data is stored in a cell at the start of the
    interval. The END is stored as a cell attribute. For variant intervals
    (such as deletions and gVCF REF blocks), an additional cell is stored at
    the END value of the variant interval. When queried for a given genomic
    position, the query library performs an efficient sweep to determine all
    intervals that intersect with the queried position.
 .
 This package contains some tools to be run as executable files.

Package: libgenomicsdb1
Section: libs
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         mpi-default-bin
Breaks: libgenomicsdb0 (<< 1.5.3)
Replaces: libgenomicsdb0 (<< 1.5.3)
Description: sparse array storage library for genomics (shared libraries)
 GenomicsDB is built on top of a htslib fork and an internal array storage
 system for importing, querying and transforming variant data. Variant data is
 sparse by nature (sparse relative to the whole genome) and using sparse array
 data stores is a perfect fit for storing such data.
 .
 The GenomicsDB stores variant data in a 2D array where:
  - Each column corresponds to a genomic position (chromosome + position);
  - Each row corresponds to a sample in a VCF (or CallSet in the GA4GH
    terminology);
  - Each cell contains data for a given sample/CallSet at a given position;
    data is stored in the form of cell attributes;
  - Cells are stored in column major order - this makes accessing cells with
    the same column index (i.e. data for a given genomic position over all
    samples) fast.
  - Variant interval/gVCF interval data is stored in a cell at the start of the
    interval. The END is stored as a cell attribute. For variant intervals
    (such as deletions and gVCF REF blocks), an additional cell is stored at
    the END value of the variant interval. When queried for a given genomic
    position, the query library performs an efficient sweep to determine all
    intervals that intersect with the queried position.
 .
 This package contains the shared library.

Package: libgenomicsdb-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends},
         libgenomicsdb1 (= ${binary:Version}),
         ${misc:Depends}
Description: sparse array storage library for genomics (development files)
 GenomicsDB is built on top of a htslib fork and an internal array storage
 system for importing, querying and transforming variant data. Variant data is
 sparse by nature (sparse relative to the whole genome) and using sparse array
 data stores is a perfect fit for storing such data.
 .
 The GenomicsDB stores variant data in a 2D array where:
  - Each column corresponds to a genomic position (chromosome + position);
  - Each row corresponds to a sample in a VCF (or CallSet in the GA4GH
    terminology);
  - Each cell contains data for a given sample/CallSet at a given position;
    data is stored in the form of cell attributes;
  - Cells are stored in column major order - this makes accessing cells with
    the same column index (i.e. data for a given genomic position over all
    samples) fast.
  - Variant interval/gVCF interval data is stored in a cell at the start of the
    interval. The END is stored as a cell attribute. For variant intervals
    (such as deletions and gVCF REF blocks), an additional cell is stored at
    the END value of the variant interval. When queried for a given genomic
    position, the query library performs an efficient sweep to determine all
    intervals that intersect with the queried position.
 .
 This package contains the development files and the static library.

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
 https://github.com/GenomicsDB/GenomicsDB/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian

opts="component=genomicsdb-htslib, mode=git" \
 https://github.com/GenomicsDB/htslib.git HEAD ignore

opts="component=genomicsdb-tiledb, mode=git" \
 https://github.com/OmicsDataAutomation/TileDB.git HEAD ignore
